// eslint-disable-next-line @typescript-eslint/no-unused-vars
import {
  assignNewGraphQueryResult,
  useAppDispatch,
  useGraphQueryResult,
} from '@graphpolaris/shared/data-access/store';
import React, { useEffect } from 'react';
import ReactJSONView from 'react-json-view';
import GridLayout from 'react-grid-layout';
import TestComponent from '../components/TestComponent';

const RawJSONVis = React.memo(() => {
  const graphQueryResult = useGraphQueryResult();
  console.log('update rawjson');

  useEffect(() => {
    console.log('update rawjson useEffect');
  }, [graphQueryResult]);

  useEffect(() => {
    return () => {
      console.log('unloaded RawJSONVis');
    };
  }, []);

  return (
    <div style={{ overflowY: 'auto' }}>
      <div
        style={{
          marginTop: '40px',
          paddingLeft: '30px',
        }}
      >
        <ReactJSONView
          src={graphQueryResult}
          collapsed={1}
          quotesOnKeys={false}
          displayDataTypes={false}
        />
      </div>
    </div>
  );
});

export function App() {
  const dispatch = useAppDispatch();

  // return (
  //   <>
  //     <div>
  //       <button
  //         onClick={() =>
  //           dispatch(
  //             assignNewGraphQueryResult({
  //               nodes: [
  //                 { id: 'agent/007', attributes: { name: 'Daniel Craig' } },
  //               ],
  //               links: [],
  //             })
  //           )
  //         }
  //       >
  //         Load in mock result
  //       </button>
  //       <button
  //         onClick={() =>
  //           dispatch(assignNewGraphQueryResult({ nodes: [], links: [] }))
  //         }
  //       >
  //         Remove mock result
  //       </button>
  //     </div>
  //     <RawJSONVis />
  //     <div />
  //   </>
  // );

  return (
    <GridLayout
      className="layout"
      cols={10}
      rowHeight={30}
      width={window.innerWidth}
    >
      <div
        key="schema-panel"
        data-grid={{ x: 0, y: 0, w: 3, h: 30, maxW: 5, isDraggable: false }}
      >
        <TestComponent content="Schema Panel" color="red"></TestComponent>
      </div>
      <div
        key="query-panel"
        data-grid={{ x: 3, y: 20, w: 5, h: 10, maxH: 20, isDraggable: false }}
      >
        <TestComponent content="Query Panel" color="blue"></TestComponent>
      </div>
      <div
        key="visualisation-panel"
        data-grid={{ x: 3, y: 0, w: 7, h: 20, isDraggable: false }}
      >
        <TestComponent
          content="Visualisation Panel"
          color="green"
        ></TestComponent>
      </div>
      <div
        key="history-panel"
        data-grid={{ x: 8, y: 20, w: 2, h: 10, isDraggable: false }}
      >
        <TestComponent content="History Panel" color="purple"></TestComponent>
      </div>
    </GridLayout>
  );
}

export default App;
