import styled from 'styled-components';
interface Props {
  content: string;
  color: string;
}

const Wrapper = styled.div<{ color: string }>`
  background-color: ${(props) => props.color};
  font: 'Arial';

  height: 100%;
  width: 100%;

  display: flex;
  justify-content: center;
  align-items: center;
  border-radius: 8px;
`;

const Content = styled.div`
  padding: 1em;
  background-color: white;
  border-radius: 8px;
`;

const TestComponent = (props: Props) => {
  return (
    <Wrapper color={props.color}>
      <Content>
        <h1>{props.content}</h1>
      </Content>
    </Wrapper>
  );
};

export default TestComponent;
